unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls,  CommCtrl,
  ShellAPI   // DragAcceptFiles
  ;


type

  { TMyCustomTreeView }
  TMyCustomListView = class(TCustomListView)
    private
       //FWndHandle: HWND;
       //FDefProc: Pointer;
       //FWndProcInstance: Pointer;
    protected
       //procedure WndProc( var Message: TMessage ); reintroduce;
       procedure WndProc( var Message: TMessage ); override;
       //procedure InitFDragControl;
       //procedure DestroyFDragControl;
       //procedure WndProcSubclassed( var Msg: TMessage );  reintroduce;
    public
      constructor Create(AOwner: TComponent); override;
      destructor Destroy; override;
    published
    end;


type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
    MyCustomListView1 : TCustomListView;
  protected
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;


implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
   MyCustomListView1 := TMyCustomListView.Create(Self);
   with MyCustomListView1 do begin
       Parent := Panel1;
       Align := alClient;
   end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   MyCustomListView1.Free;
end;

procedure TMyCustomListView.WndProc(var Message: TMessage);
var wmmesg: String;
begin
  with Message do begin
    Case Msg Of
      WM_CREATE : ShowMessage('WndProc: received WM_CREATE');
      WM_DROPFILES : ShowMessage('WndProc: received WM_DROPFILES');
    end;
  end;
  inherited;
end;

constructor TMyCustomListView.Create(AOwner: TComponent);
var aWinCtl: TWinControl; aWndHandle: HWND;
begin
  inherited Create(AOwner);
  viewStyle := vsReport;
  //FWndHandle := 0;
  //InitFDragControl;

     aWinCtl := TWinControl( AOwner );
     aWndHandle := aWinCtl.Handle;

  DragAcceptFiles( aWndHandle, True );
end;

destructor TMyCustomListView.Destroy;
begin
  //DestroyFDragControl;
  inherited Destroy;
end;

{
procedure TMyCustomListView.WndProcSubclassed( var Msg: TMessage );
begin
  with Msg do begin
    if Msg = WM_DROPFILES then
       ShowMessage('WndProcSubclassed: received WM_DROPFILES')
    else
       Result := CallWindowProc( FDefProc, FWndHandle, Msg, WParam, LParam);
  end;
end;

procedure TMyCustomListView.InitFDragControl;
var WinCtl: TWinControl;
begin
   if Owner is TWinControl then
    begin
      // Subclass the owner so this control can capture the WM_DROPFILES message
      WinCtl := TWinControl( Owner );
      FWndHandle := WinCtl.Handle;
      FWndProcInstance := MakeObjectInstance( WndProcSubclassed );
      FDefProc := Pointer( GetWindowLong( FWndHandle, GWL_WNDPROC ));
      SetWindowLong( FWndHandle, GWL_WNDPROC, Longint( FWndProcInstance ));
    end
   else
end;

procedure TMyCustomListView.DestroyFDragControl;  //878_DragDrop<
begin
  if FWndHandle <> 0 then begin
     // Restore the original window procedure
     SetWindowLong( FWndHandle, GWL_WNDPROC, Longint( FDefProc ));
     FreeObjectInstance(FWndProcInstance);
   end
end;
}

end.
